' 		BLOC_PC.BAS
'	
'   Source en Basic 11 (CONTROLORD) du montage VERROUILLAGE PC
'
'Le code plac en EEPROM pourra tre chang avant compilation
'Respecter la syntaxe: exemple si vous voulez le code 1234,
'remplacer CODE()=1,9,9,8 par CODE()=1,2,3,4	
'
'       LEDS       CODE(1,4)    ON(Verte)    OFF(Rouge):
'                   PB3  0      PC6           PC7
'
'	relais     Clavier PC  et   Souris :
'		     PB7	    PB6
'
'	clavier      lignes 	    colonnes
'		    PD2  PD4        PA3  PA6		    

#include "starta1.bas"	'fichier de dmarrage pour 68HC11A1


	byte	 CODE()=1,9,9,8		'code en mmoire EEPROM ( changer)
	byte 	 CLAV(4)		'code saisi au clavier:4 cases
					'mmoires pour CLAV		
	byte	 KEY,i,N,NN,comp,j


	DDRD  = 0			' PD5=PD4=PD3=PD2=entres
	DDRC = 0xFF
DEBUT:  PORTB = 0xFF			'Leds code teintes,blocage PC
	PORTC.7=0			'Led rouge allume
	PORTC.6=1			'Led verte teinte			
	N=0
		
LECT1:	tempo(150)			'temporisation
LEC:	KEY=keyget()			'rsultat lecture d'une touche dans 
					'la variable KEY
	if KEY >10 then goto LECT1	'si appui sur #
	
	if KEY =10 then 		'si appui sur *
	 if N=0 then goto DEBUT		
	N=N-1				'retour sur le nombre prcdent
	goto ALLUM			'pour correction
	end if
	if KEY <= 9 then		'si appui sur touche 0  9 
	CLAV(N)=KEY			'mettre le nombre dans CLAV
	N=N+1				'passer au nombre suivant
	
ALLUM:	if N=1 then PORTB=%11111110	'allume 1  4 Leds en fonction
	if N=2 then PORTB=%11111100	'du nombres de touches numriques
	if N=3 then PORTB=%11111000	'appuyes
	if N=4 then 
	  PORTB=%11110000
	  comp = 0
	  goto COMPAR
	end if
	end if
	goto LECT1
	
COMPAR: for NN = 0 to 3 step 1		'comparaison entre le code entr
	if CLAV(NN)=CODE(NN)then 	'(CLAV) et le code en mmoire
	  comp = comp+1			'(CODE)
	else
	  comp = 0
	end if
	next NN
	if comp <> 4 then 		'si les quatres chiffres de CLAV
	tempo(200)			'sont diffrents de ceux de CODE 
	 goto DEBUT			'retourner au dbut
	end if
				'sinon c'est OK donc dbloquer le PC
OK:	PORTC.7=1		'Led rouge teinte
	PORTC.6=0		'Led verte allume
	PORTB.7=0		'dblocage clavier
	PORTB.6=0		'dblocage souris
	
	for i = 0 to 1 step 0	
LECT2:	KEY=keyget()			'blocage immdiat du PC 
	if KEY=0x0B then goto DEBUT	'si touche # appuye
	next i
	goto LECT2


function keyget()			'lecture du clavier
	byte keycode, old_a
	old_a = PORTA
	keycode = 0x0C
	PORTA.3 = 0					
	PORTA.4 = 1
	PORTA.5 = 1
	PORTA.6 = 1					
	if PORTD.2 = 0 then keycode= 1		
	if PORTD.3 = 0 then keycode= 2
	if PORTD.4 = 0 then keycode= 3
	PORTA.3 = 1					
	PORTA.4 = 0
	PORTA.5 = 1
	PORTA.6 = 1	
	if PORTD.2 = 0 then keycode= 4
	if PORTD.3 = 0 then keycode= 5
	if PORTD.4 = 0 then keycode= 6
	PORTA.3 = 1					
	PORTA.4 = 1
	PORTA.5 = 0
	PORTA.6 = 1	
	if PORTD.2 = 0 then keycode= 7
	if PORTD.3 = 0 then keycode= 8
	if PORTD.4 = 0 then keycode= 9
	PORTA.3 = 1					
	PORTA.4 = 1
	PORTA.5 = 1
	PORTA.6 = 0	
	if PORTD.2 = 0 then keycode= 0xA	
	if PORTD.3 = 0 then keycode= 0		
	if PORTD.4 = 0 then keycode= 0xB	
	PORTA = old_a
	return keycode
	end function

function tempo(cnt)		'fonction de temporisation
	byte z
	for cnt=cnt to 0 step -1
		for z=0 to 100
		next z
	next cnt
end function

